# Define known properties

> The cycle structure and the known properties must be defined entirely within the `@solve` macro, following the syntax presented in this documentation.

To define properties that are already known to the system, you must specify the state and symbol of the known property, following the table below.

> | Property thermodynamics        | Unit                 | Symbol of attributes of the state    |
> | :---             | ---:                 | :---:                   |
> | Temperature      | K                    | .T                      |
> | Pressure         | kPa                  | .p                      |
> | Enthalpy         | kJ/kg                | .h                      |
> | Entropy          | kJ/kg.K              | .s                      |
> | Quality          |                      | .Q                      |
> | Density          | kg/m^3               | .rho                    |
> | Mass flow        | kg/s                 | .m                      |

Based on this, to assign the properties, the name of the state is concatenated with the symbol of the known attribute, followed by the equal sign and the value to be assigned, taking into account the units of each property.